diff -bruN freeswan-1.9.orig/lib/pfkey_v2_build.c freeswan-1.9/lib/pfkey_v2_build.c
--- freeswan-1.9.orig/lib/pfkey_v2_build.c	Fri Nov 17 13:10:30 2000
+++ freeswan-1.9/lib/pfkey_v2_build.c	Wed May 16 10:57:20 2001
@@ -12,14 +12,14 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: pfkey_v2_build.c,v 1.21 2000/11/17 18:10:30 rgb Exp $
+ * RCSID $Id: pfkey_v2_build.c,v 1.24 2001/03/20 03:49:45 rgb Exp $
  */
 
 /*
  *		Template from klips/net/ipsec/ipsec/ipsec_parser.c.
  */
 
-char pfkey_v2_build_c_version[] = "$Id: pfkey_v2_build.c,v 1.21 2000/11/17 18:10:30 rgb Exp $";
+char pfkey_v2_build_c_version[] = "$Id: pfkey_v2_build.c,v 1.24 2001/03/20 03:49:45 rgb Exp $";
 
 /*
  * Some ugly stuff to allow consistent debugging code for use in the
@@ -41,10 +41,10 @@
 # if defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE)
 #  include <linux/ipv6.h>        /* struct ipv6hdr */
 # endif /* if defined(CONFIG_IPV6) || defined(CONFIG_IPV6_MODULE) */
-extern int debug_pfkey;
 
 # define MALLOC(size) kmalloc(size, GFP_ATOMIC)
 # define FREE(obj) kfree(obj)
+# include <freeswan.h>
 #else /* __KERNEL__ */
 
 # include <sys/types.h>
@@ -53,6 +53,7 @@
 # include <malloc.h>
 # include <string.h> /* memset */
 
+# include <freeswan.h>
 # include "../pluto/constants.h" 
 # include "../pluto/defs.h"  /* for PRINTF_LIKE */
 # include "../pluto/log.h"  /* for debugging and DBG_log */
@@ -71,7 +72,6 @@
 # define FREE(obj) free(obj)
 #endif /* __KERNEL__ */
 
-#include <freeswan.h>
 #include <pfkeyv2.h>
 #include <pfkey.h>
 
@@ -147,33 +147,38 @@
 	DEBUGGING(
 		"pfkey_msg_hdr_build:\n");
 	DEBUGGING(
-		"pfkey_msg_hdr_build: on_entry &pfkey_ext=%p pfkey_ext=%p *pfkey_ext=%p.\n",
+		"pfkey_msg_hdr_build: "
+		"on_entry &pfkey_ext=%p pfkey_ext=%p *pfkey_ext=%p.\n",
 		&pfkey_ext,
 		pfkey_ext,
 		*pfkey_ext);
 	/* sanity checks... */
 	if(pfkey_msg) {
 		DEBUGGING(
-			"pfkey_msg_hdr_build:why is pfkey_msg already pointing to something?\n");
+			"pfkey_msg_hdr_build: "
+			"why is pfkey_msg already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	if(!msg_type) {
 		DEBUGGING(
-			"pfkey_msg_hdr_build: msg type not set, must be non-zero..\n");
+			"pfkey_msg_hdr_build: "
+			"msg type not set, must be non-zero..\n");
 		SENDERR(EINVAL);
 	}
 
 	if(msg_type > SADB_MAX) {
 		DEBUGGING(
-			"pfkey_msg_hdr_build: msg type too large:%d.\n",
+			"pfkey_msg_hdr_build: "
+			"msg type too large:%d.\n",
 			msg_type);
 		SENDERR(EINVAL);
 	}
 
 	if(satype > SADB_SATYPE_MAX) {
 		DEBUGGING(
-			"pfkey_msg_hdr_build: satype %d > max %d\n", 
+			"pfkey_msg_hdr_build: "
+			"satype %d > max %d\n", 
 			satype, SADB_SATYPE_MAX);
 		SENDERR(EINVAL);
 	}
@@ -182,7 +187,8 @@
 	     pfkey_msg = (struct sadb_msg*)
 	     MALLOC(sizeof(struct sadb_msg)))) {
 		DEBUGGING(
-			"pfkey_msg_hdr_build: memory allocation failed\n");
+			"pfkey_msg_hdr_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_msg, 0, sizeof(struct sadb_msg));
@@ -198,7 +204,8 @@
 	pfkey_msg->sadb_msg_seq = seq;
 	pfkey_msg->sadb_msg_pid = pid;
 	DEBUGGING(
-		"pfkey_msg_hdr_build: on_exit &pfkey_ext=%p pfkey_ext=%p *pfkey_ext=%p.\n",
+		"pfkey_msg_hdr_build: "
+		"on_exit &pfkey_ext=%p pfkey_ext=%p *pfkey_ext=%p.\n",
 		&pfkey_ext,
 		pfkey_ext,
 		*pfkey_ext);
@@ -220,7 +227,8 @@
 	struct sadb_sa *pfkey_sa = (struct sadb_sa *)*pfkey_ext;
 
 	DEBUGGING(
-		    "pfkey_sa_build: spi=%08x replay=%d sa_state=%d auth=%d encrypt=%d flags=%d\n",
+		    "pfkey_sa_build: "
+		    "spi=%08x replay=%d sa_state=%d auth=%d encrypt=%d flags=%d\n",
 		    ntohl(spi), /* in network order */
 		    replay_window,
 		    sa_state,
@@ -230,29 +238,32 @@
 	/* sanity checks... */
 	if(pfkey_sa) {
 		DEBUGGING(
-			"pfkey_sa_build:why is pfkey_sa already pointing to something?\n");
+			"pfkey_sa_build: "
+			"why is pfkey_sa already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	if(exttype != SADB_EXT_SA &&
 	   exttype != SADB_X_EXT_SA2) {
 		DEBUGGING(
-			"pfkey_sa_build: invalid exttype=%d.\n",
+			"pfkey_sa_build: "
+			"invalid exttype=%d.\n",
 			exttype);
 		SENDERR(EINVAL);
 	}
 
 	if(replay_window > 64) {
 		DEBUGGING(
-			"pfkey_sa_build: replay window size: %d"
-			" -- must be 0 <= size <= 64\n",
+			"pfkey_sa_build: "
+			"replay window size: %d -- must be 0 <= size <= 64\n",
 			replay_window);
 		SENDERR(EINVAL);
 	}
 
 	if(auth > SADB_AALG_MAX) {
 		DEBUGGING(
-			"pfkey_sa_build: auth=%d > SADB_AALG_MAX=%d.\n",
+			"pfkey_sa_build: "
+			"auth=%d > SADB_AALG_MAX=%d.\n",
 			auth,
 			SADB_AALG_MAX);
 		SENDERR(EINVAL);
@@ -260,7 +271,8 @@
 
 	if(encrypt > SADB_EALG_MAX) {
 		DEBUGGING(
-			"pfkey_sa_build: encrypt=%d > SADB_EALG_MAX=%d.\n",
+			"pfkey_sa_build: "
+			"encrypt=%d > SADB_EALG_MAX=%d.\n",
 			encrypt,
 			SADB_EALG_MAX);
 		SENDERR(EINVAL);
@@ -268,7 +280,8 @@
 
 	if(sa_state > SADB_SASTATE_MAX) {
 		DEBUGGING(
-			"pfkey_sa_build: sa_state=%d exceeds MAX=%d.\n",
+			"pfkey_sa_build: "
+			"sa_state=%d exceeds MAX=%d.\n",
 			sa_state,
 			SADB_SASTATE_MAX);
 		SENDERR(EINVAL);
@@ -276,7 +289,8 @@
 
 	if(sa_state == SADB_SASTATE_DEAD) {
 		DEBUGGING(
-			"pfkey_sa_build: sa_state=%d is DEAD=%d is not allowed.\n",
+			"pfkey_sa_build: "
+			"sa_state=%d is DEAD=%d is not allowed.\n",
 			sa_state,
 			SADB_SASTATE_DEAD);
 		SENDERR(EINVAL);
@@ -286,7 +300,8 @@
 	     pfkey_sa = (struct sadb_sa*)
 	     MALLOC(sizeof(struct sadb_sa)))) {
 		DEBUGGING(
-			"pfkey_sa_build: memory allocation failed\n");
+			"pfkey_sa_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_sa, 0, sizeof(struct sadb_sa));
@@ -320,7 +335,8 @@
 	/* sanity checks... */
 	if(pfkey_lifetime) {
 		DEBUGGING(
-			"pfkey_lifetime_build:why is pfkey_lifetime already pointing to something?\n");
+			"pfkey_lifetime_build: "
+			"why is pfkey_lifetime already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
@@ -328,7 +344,8 @@
 	   exttype != SADB_EXT_LIFETIME_HARD &&
 	   exttype != SADB_EXT_LIFETIME_SOFT) {
 		DEBUGGING(
-			"pfkey_lifetime_build: invalid exttype=%d.\n",
+			"pfkey_lifetime_build: "
+			"invalid exttype=%d.\n",
 			exttype);
 		SENDERR(EINVAL);
 	}
@@ -337,7 +354,8 @@
 	     pfkey_lifetime = (struct sadb_lifetime*)
 	     MALLOC(sizeof(struct sadb_lifetime)))) {
 		DEBUGGING(
-			"pfkey_lifetime_build: memory allocation failed\n");
+			"pfkey_lifetime_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_lifetime, 0, sizeof(struct sadb_lifetime));
@@ -366,16 +384,22 @@
 	struct sadb_address *pfkey_address = (struct sadb_address *)*pfkey_ext;
 	
 	DEBUGGING(
-		"pfkey_address_build: exttype=%d proto=%d prefixlen=%d\n", exttype, proto, prefixlen);
+		"pfkey_address_build: "
+		"exttype=%d proto=%d prefixlen=%d\n",
+		exttype,
+		proto,
+		prefixlen);
 	/* sanity checks... */
 	if(pfkey_address) {
 		DEBUGGING(
-			"pfkey_address_build:why is pfkey_address already pointing to something?\n");
+			"pfkey_address_build: "
+			"why is pfkey_address already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	if (!address)  {
-			DEBUGGING("pfkey_address_build: address is NULL\n");
+			DEBUGGING("pfkey_address_build: "
+				  "address is NULL\n");
 			SENDERR(EINVAL);
 	}
 	
@@ -391,7 +415,8 @@
 		break;
 	default:
 		DEBUGGING( 
-			"pfkey_address_build: unrecognised ext_type=%d.\n", 
+			"pfkey_address_build: "
+			"unrecognised ext_type=%d.\n", 
 			exttype); 
 		SENDERR(EINVAL); 
 	}
@@ -399,7 +424,8 @@
 	switch(address->sa_family) {
 	case AF_INET:
 		DEBUGGING(
-			"pfkey_address_build: found address family AF_INET.\n");
+			"pfkey_address_build: "
+			"found address family AF_INET.\n");
 		saddr_len = sizeof(struct sockaddr_in);
 		sprintf(ipaddr_txt, "%d.%d.%d.%d"
 			, (((struct sockaddr_in*)address)->sin_addr.s_addr >>  0) & 0xFF
@@ -409,7 +435,8 @@
 		break;
 	case AF_INET6:
 		DEBUGGING(
-			"pfkey_address_build: found address family AF_INET6.\n");
+			"pfkey_address_build: "
+			"found address family AF_INET6.\n");
 		saddr_len = sizeof(struct sockaddr_in6);
 		sprintf(ipaddr_txt, "%x:%x:%x:%x:%x:%x:%x:%x"
 			, ntohs(((struct sockaddr_in6*)address)->sin6_addr.s6_addr16[0])
@@ -423,17 +450,20 @@
 		break;
 	default:
 		DEBUGGING(
-			"pfkey_address_build: address->sa_family=%d not supported.\n",
+			"pfkey_address_build: "
+			"address->sa_family=%d not supported.\n",
 			address->sa_family);
 		SENDERR(EPFNOSUPPORT);
 	}
 
 	DEBUGGING(
-		"pfkey_address_build: found address=%s.\n",
+		"pfkey_address_build: "
+		"found address=%s.\n",
 		ipaddr_txt);
 	if(prefixlen != 0) {
 		DEBUGGING(
-			"pfkey_address_build: address prefixes not supported yet.\n");
+			"pfkey_address_build: "
+			"address prefixes not supported yet.\n");
 		SENDERR(EAFNOSUPPORT); /* not supported yet */
 	}
 
@@ -441,7 +471,8 @@
 	     pfkey_address = (struct sadb_address*)
 	     MALLOC(ALIGN_N(sizeof(struct sadb_address) + saddr_len, IPSEC_PFKEYv2_ALIGN) ))) {
 		DEBUGGING(
-			"pfkey_lifetime_build: memory allocation failed\n");
+			"pfkey_lifetime_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_address,
@@ -467,7 +498,8 @@
 	}
 #endif
 	DEBUGGING(
-		"pfkey_address_build: successful.\n");
+		"pfkey_address_build: "
+		"successful.\n");
 
  errlab:
 	return error;
@@ -487,19 +519,22 @@
 	/* sanity checks... */
 	if(pfkey_key) {
 		DEBUGGING(
-			"pfkey_key_build:why is pfkey_key already pointing to something?\n");
+			"pfkey_key_build: "
+			"why is pfkey_key already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	if(!key_bits) {
 		DEBUGGING(
-			"pfkey_key_build: key_bits is zero, it must be non-zero.\n");
+			"pfkey_key_build: "
+			"key_bits is zero, it must be non-zero.\n");
 		SENDERR(EINVAL);
 	}
 
 	if( !((exttype == SADB_EXT_KEY_AUTH) || (exttype == SADB_EXT_KEY_ENCRYPT))) {
 		DEBUGGING(
-			"pfkey_key_build: unsupported extension type=%d.\n",
+			"pfkey_key_build: "
+			"unsupported extension type=%d.\n",
 			exttype);
 		SENDERR(EINVAL);
 	}
@@ -509,7 +544,8 @@
 	     MALLOC(sizeof(struct sadb_key) +
 				    DIVUP(key_bits, 64) * IPSEC_PFKEYv2_ALIGN))) {
 		DEBUGGING(
-			"pfkey_key_build: memory allocation failed\n");
+			"pfkey_key_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_key,
@@ -545,27 +581,31 @@
 	/* sanity checks... */
 	if(pfkey_ident) {
 		DEBUGGING(
-			"pfkey_ident_build:why is pfkey_ident already pointing to something?\n");
+			"pfkey_ident_build: "
+			"why is pfkey_ident already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	if( ! ((exttype == SADB_EXT_IDENTITY_SRC) ||
 	       (exttype == SADB_EXT_IDENTITY_DST))) {
 		DEBUGGING(
-			"pfkey_ident_build: unsupported extension type=%d.\n",
+			"pfkey_ident_build: "
+			"unsupported extension type=%d.\n",
 			exttype);
 		SENDERR(EINVAL);
 	}
 
 	if((ident_type == SADB_IDENTTYPE_RESERVED)) {
 		DEBUGGING(
-			"pfkey_ident_build: ident_type must be non-zero.\n");
+			"pfkey_ident_build: "
+			"ident_type must be non-zero.\n");
 		SENDERR(EINVAL);
 	}
 
 	if(ident_type > SADB_IDENTTYPE_MAX) {
 		DEBUGGING(
-			"pfkey_ident_build: identtype=%d out of range.\n",
+			"pfkey_ident_build: "
+			"identtype=%d out of range.\n",
 			ident_type);
 		SENDERR(EINVAL);
 	}
@@ -574,7 +614,8 @@
 	    (ident_type == SADB_IDENTTYPE_FQDN)) &&
 	   !ident_string) {
 		DEBUGGING(
-			"pfkey_ident_build: string required to allocate size of extension.\n");
+			"pfkey_ident_build: "
+			"string required to allocate size of extension.\n");
 		SENDERR(EINVAL);
 	}
 	
@@ -587,7 +628,8 @@
 	     pfkey_ident = (struct sadb_ident*)
 	     MALLOC(ALIGN_N(sizeof(struct sadb_key) + strlen(ident_string), IPSEC_PFKEYv2_ALIGN)))) {
 		DEBUGGING(
-			"pfkey_ident_build: memory allocation failed\n");
+			"pfkey_ident_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_ident,
@@ -645,12 +687,14 @@
 	/* sanity checks... */
 	if(pfkey_sens) {
 		DEBUGGING(
-			"pfkey_sens_build:why is pfkey_sens already pointing to something?\n");
+			"pfkey_sens_build: "
+			"why is pfkey_sens already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	DEBUGGING(
-		"pfkey_sens_build: Sorry, I can't build exttype=%d yet.\n",
+		"pfkey_sens_build: "
+		"Sorry, I can't build exttype=%d yet.\n",
 		(*pfkey_ext)->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 
@@ -659,7 +703,8 @@
 	     MALLOC(sizeof(struct sadb_sens) +
 		    (sens_len + integ_len) * sizeof(uint64_t)))) {
 		DEBUGGING(
-			"pfkey_sens_build: memory allocation failed\n");
+			"pfkey_sens_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_sens,
@@ -707,7 +752,8 @@
 	/* sanity checks... */
 	if(pfkey_prop) {
 		DEBUGGING(
-			"pfkey_prop_build:why is pfkey_prop already pointing to something?\n");
+			"pfkey_prop_build: "
+			"why is pfkey_prop already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
@@ -716,7 +762,8 @@
 	     MALLOC(sizeof(struct sadb_prop) +
 		    comb_num * sizeof(struct sadb_comb)))) {
 		DEBUGGING(
-			"pfkey_prop_build: memory allocation failed\n");
+			"pfkey_prop_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_prop,
@@ -776,13 +823,15 @@
 	/* sanity checks... */
 	if(pfkey_supported) {
 		DEBUGGING(
-			"pfkey_supported_build:why is pfkey_supported already pointing to something?\n");
+			"pfkey_supported_build: "
+			"why is pfkey_supported already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 
 	if( !((exttype == SADB_EXT_SUPPORTED_AUTH) || (exttype == SADB_EXT_SUPPORTED_ENCRYPT))) {
 		DEBUGGING(
-			"pfkey_supported_build: unsupported extension type=%d.\n",
+			"pfkey_supported_build: "
+			"unsupported extension type=%d.\n",
 			exttype);
 		SENDERR(EINVAL);
 	}
@@ -793,7 +842,8 @@
 					       alg_num *
 					       sizeof(struct sadb_alg)))) {
 		DEBUGGING(
-			"pfkey_supported_build: memory allocation failed\n");
+			"pfkey_supported_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_supported,
@@ -818,7 +868,8 @@
 	
 #if 0
 	DEBUGGING(
-		"pfkey_supported_build: Sorry, I can't build exttype=%d yet.\n",
+		"pfkey_supported_build: "
+		"Sorry, I can't build exttype=%d yet.\n",
 		(*pfkey_ext)->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 
@@ -844,13 +895,15 @@
 	/* sanity checks... */
 	if(pfkey_spirange) {
 		DEBUGGING(
-			"pfkey_spirange_build:why is pfkey_spirange already pointing to something?\n");
+			"pfkey_spirange_build: "
+			"why is pfkey_spirange already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 	
         if(ntohl(max) < ntohl(min)) {
 		DEBUGGING(
-			"pfkey_spirange_build: minspi=%08x must be < maxspi=%08x.\n",
+			"pfkey_spirange_build: "
+			"minspi=%08x must be < maxspi=%08x.\n",
 			ntohl(min),
 			ntohl(max));
                 SENDERR(EINVAL);
@@ -858,7 +911,8 @@
 	
 	if(ntohl(min) <= 255) {
 		DEBUGGING(
-			"pfkey_spirange_build: minspi=%08x must be > 255.\n",
+			"pfkey_spirange_build: "
+			"minspi=%08x must be > 255.\n",
 			ntohl(min));
 		SENDERR(EEXIST);
 	}
@@ -867,7 +921,8 @@
 	     pfkey_spirange = (struct sadb_spirange*)
 	     MALLOC(sizeof(struct sadb_spirange)))) {
 		DEBUGGING(
-			"pfkey_spirange_build: memory allocation failed\n");
+			"pfkey_spirange_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_spirange,
@@ -893,14 +948,16 @@
 	/* sanity checks... */
 	if(pfkey_x_kmprivate) {
 		DEBUGGING(
-			"pfkey_x_kmprivate_build:why is pfkey_x_kmprivate already pointing to something?\n");
+			"pfkey_x_kmprivate_build: "
+			"why is pfkey_x_kmprivate already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 	
 	pfkey_x_kmprivate->sadb_x_kmprivate_reserved = 0;
 
 	DEBUGGING(
-		"pfkey_x_kmprivate_build: Sorry, I can't build exttype=%d yet.\n",
+		"pfkey_x_kmprivate_build: "
+		"Sorry, I can't build exttype=%d yet.\n",
 		(*pfkey_ext)->sadb_ext_type);
 	SENDERR(EINVAL); /* don't process these yet */
 
@@ -908,7 +965,8 @@
 	     pfkey_x_kmprivate = (struct sadb_x_kmprivate*)
 	     MALLOC(sizeof(struct sadb_x_kmprivate)))) {
 		DEBUGGING(
-			"pfkey_x_kmprivate_build: memory allocation failed\n");
+			"pfkey_x_kmprivate_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_x_kmprivate,
@@ -937,19 +995,22 @@
 	/* sanity checks... */
 	if(pfkey_x_satype) {
 		DEBUGGING(
-			"pfkey_x_satype_build:why is pfkey_x_satype already pointing to something?\n");
+			"pfkey_x_satype_build: "
+			"why is pfkey_x_satype already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 	
 	if(!satype) {
 		DEBUGGING(
-			"pfkey_x_satype_build: SA type not set, must be non-zero.\n");
+			"pfkey_x_satype_build: "
+			"SA type not set, must be non-zero.\n");
 		SENDERR(EINVAL);
 	}
 
 	if(satype > SADB_SATYPE_MAX) {
 		DEBUGGING(
-			"pfkey_x_satype_build: satype %d > max %d\n", 
+			"pfkey_x_satype_build: "
+			"satype %d > max %d\n", 
 			satype, SADB_SATYPE_MAX);
 		SENDERR(EINVAL);
 	}
@@ -957,7 +1018,8 @@
 	if(!(*pfkey_ext = (struct sadb_ext*)pfkey_x_satype = (struct sadb_x_satype*)
 	     MALLOC(sizeof(struct sadb_x_satype)))) {
 		DEBUGGING(
-			"pfkey_x_satype_build: memory allocation failed\n");
+			"pfkey_x_satype_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 	memset(pfkey_x_satype,
@@ -1000,18 +1062,21 @@
 	/* sanity checks... */
 	if(pfkey_x_debug) {
 		DEBUGGING(
-			"pfkey_x_debug_build:why is pfkey_x_debug already pointing to something?\n");
+			"pfkey_x_debug_build: "
+			"why is pfkey_x_debug already pointing to something?\n");
 		SENDERR(EINVAL);
 	}
 	
 	DEBUGGING(
-		"pfkey_x_debug_build:tunnel=%x netlink=%x xform=%x eroute=%x spi=%x radij=%x esp=%x ah=%x rcv=%x pfkey=%x ipcomp=%x verbose=%x?\n",
+		"pfkey_x_debug_build: "
+		"tunnel=%x netlink=%x xform=%x eroute=%x spi=%x radij=%x esp=%x ah=%x rcv=%x pfkey=%x ipcomp=%x verbose=%x?\n",
 		tunnel, netlink, xform, eroute, spi, radij, esp, ah, rcv, pfkey, ipcomp, verbose);
 
 	if(!(*pfkey_ext = (struct sadb_ext*)pfkey_x_debug = (struct sadb_x_debug*)
 	     MALLOC(sizeof(struct sadb_x_debug)))) {
 		DEBUGGING(
-			"pfkey_x_debug_build: memory allocation failed\n");
+			"pfkey_x_debug_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 #if 0
@@ -1089,7 +1154,8 @@
 	
 	if(!extensions[0]) {
 		DEBUGGING(
-			"pfkey_msg_build: extensions[0] must be specified (struct sadb_msg).\n");
+			"pfkey_msg_build: "
+			"extensions[0] must be specified (struct sadb_msg).\n");
 		SENDERR(EINVAL);
 	}
 
@@ -1102,12 +1168,14 @@
 
 	if(!(*pfkey_msg = (struct sadb_msg*)MALLOC(total_size * IPSEC_PFKEYv2_ALIGN))) {
 		DEBUGGING(
-			"pfkey_msg_build: memory allocation failed\n");
+			"pfkey_msg_build: "
+			"memory allocation failed\n");
 		SENDERR(ENOMEM);
 	}
 
 	DEBUGGING(
-		"pfkey_msg_build: pfkey_msg=%p allocated %d bytes, &(extensions[0])=%p\n",
+		"pfkey_msg_build: "
+		"pfkey_msg=%p allocated %d bytes, &(extensions[0])=%p\n",
 		*pfkey_msg,
 		total_size * IPSEC_PFKEYv2_ALIGN,
 		&(extensions[0]));
@@ -1135,7 +1203,8 @@
 				SENDERR(EINVAL);
 			}
 			DEBUGGING(
-				"pfkey_msg_build: copying %d bytes from extensions[%d]=%p to=%p\n",
+				"pfkey_msg_build: "
+				"copying %d bytes from extensions[%d]=%p to=%p\n",
 				(extensions[ext])->sadb_ext_len * IPSEC_PFKEYv2_ALIGN,
 				ext,
 				(extensions[ext]),
@@ -1151,8 +1220,8 @@
 
 	/* check required extensions */
 	DEBUGGING(
-		"pfkey_msg_build: extensions "
-		"permitted=%08x, seen=%08x, required=%08x.\n",
+		"pfkey_msg_build: "
+		"extensions permitted=%08x, seen=%08x, required=%08x.\n",
 		extensions_bitmaps[dir][EXT_BITS_PERM][(*pfkey_msg)->sadb_msg_type],
 		extensions_seen,
 		extensions_bitmaps[dir][EXT_BITS_REQ][(*pfkey_msg)->sadb_msg_type]);
@@ -1161,7 +1230,8 @@
 	    extensions_bitmaps[dir][EXT_BITS_REQ][(*pfkey_msg)->sadb_msg_type]) !=
 	   extensions_bitmaps[dir][EXT_BITS_REQ][(*pfkey_msg)->sadb_msg_type]) {
 		DEBUGGING(
-			"pfkey_msg_build: required extensions missing:%08x.\n",
+			"pfkey_msg_build: "
+			"required extensions missing:%08x.\n",
 			extensions_bitmaps[dir][EXT_BITS_REQ][(*pfkey_msg)->sadb_msg_type] -
 			(extensions_seen &
 			 extensions_bitmaps[dir][EXT_BITS_REQ][(*pfkey_msg)->sadb_msg_type]) );
@@ -1170,7 +1240,8 @@
 	
 	if((error = pfkey_msg_parse(*pfkey_msg, NULL, extensions_check, dir))) {
 		DEBUGGING(
-			"pfkey_msg_build: Trouble parsing newly built pfkey message, error=%d.\n",
+			"pfkey_msg_build: "
+			"Trouble parsing newly built pfkey message, error=%d.\n",
 			error);
 		SENDERR(-error);
 	}
@@ -1182,6 +1253,17 @@
 
 /*
  * $Log: pfkey_v2_build.c,v $
+ * Revision 1.24  2001/03/20 03:49:45  rgb
+ * Ditch superfluous debug_pfkey declaration.
+ * Move misplaced freeswan.h inclusion for kernel case.
+ *
+ * Revision 1.23  2001/03/16 07:41:50  rgb
+ * Put freeswan.h include before pluto includes.
+ *
+ * Revision 1.22  2001/02/27 22:24:56  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
  * Revision 1.21  2000/11/17 18:10:30  rgb
  * Fixed bugs mostly relating to spirange, to treat all spi variables as
  * network byte order since this is the way PF_KEYv2 stored spis.
diff -bruN freeswan-1.9.orig/lib/pfkey_v2_ext_bits.c freeswan-1.9/lib/pfkey_v2_ext_bits.c
--- freeswan-1.9.orig/lib/pfkey_v2_ext_bits.c	Tue Sep 12 18:35:37 2000
+++ freeswan-1.9/lib/pfkey_v2_ext_bits.c	Wed May 16 10:57:20 2001
@@ -12,14 +12,14 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: pfkey_v2_ext_bits.c,v 1.7 2000/09/12 22:35:37 rgb Exp $
+ * RCSID $Id: pfkey_v2_ext_bits.c,v 1.8 2001/03/26 23:07:36 rgb Exp $
  */
 
 /*
  *		Template from klips/net/ipsec/ipsec/ipsec_parse.c.
  */
 
-char pfkey_v2_ext_bits_c_version[] = "$Id: pfkey_v2_ext_bits.c,v 1.7 2000/09/12 22:35:37 rgb Exp $";
+char pfkey_v2_ext_bits_c_version[] = "$Id: pfkey_v2_ext_bits.c,v 1.8 2001/03/26 23:07:36 rgb Exp $";
 
 /*
  * Some ugly stuff to allow consistent debugging code for use in the
@@ -226,8 +226,8 @@
 | 1<<SADB_EXT_SA
 | 1<<SADB_EXT_ADDRESS_SRC
 | 1<<SADB_EXT_ADDRESS_DST
-| 1<<SADB_EXT_KEY_AUTH
-| 1<<SADB_EXT_KEY_ENCRYPT
+/*| 1<<SADB_EXT_KEY_AUTH*/
+/*| 1<<SADB_EXT_KEY_ENCRYPT*/
 ,
 /* SADB_ADD */
 1<<SADB_EXT_RESERVED
@@ -670,6 +670,9 @@
 
 /*
  * $Log: pfkey_v2_ext_bits.c,v $
+ * Revision 1.8  2001/03/26 23:07:36  rgb
+ * Remove requirement for auth and enc key from UPDATE.
+ *
  * Revision 1.7  2000/09/12 22:35:37  rgb
  * Restructured to remove unused extensions from CLEARFLOW messages.
  *
